{
  "x-generator": "On Key REST API Docs Generator",
  "swagger": "2.0",
  "info": {
    "title": "On Key AOM  API Specification",
    "description": "Better and smarter enterprise asset management with one of the world's leading Enterprise Asset Management (EAM) systems.",
    "termsOfService": "https://www.onkey.com/",
    "contact": {
      "name": "On Key Support",
      "url": "https://www.onkey.com/",
      "email": "onkey.support@pragmaworld.net"
    },
    "license": {
      "name": "On Key Licence",
      "url": "https://www.onkey.com/"
    },
    "version": "1.0.0"
  },
  "host": "<variable>:443",
  "basePath": "/api/tenants/{client}/{connection}",
  "schemes": [
    "https"
  ],
  "consumes": [
    "application/vnd.onkey.entity+json",
    "application/vnd.onkey.entitypatch+json",
    "application/vnd.onkey.entitydelete+json",
    "application/vnd.onkey.entitycollection+json",
    "application/vnd.onkey.entitypatchcollection+json",
    "application/vnd.onkey.entitydeletecollection+json",
    "application/vnd.onkey.entitymatchupdatecollection+json"
  ],
  "produces": [
    "application/vnd.onkey.entity+json",
    "application/vnd.onkey.notification+json",
    "application/vnd.onkey.entitycollectionpage+json",
    "application/vnd.onkey.entitycollection+json"
  ],
  "paths": {
    "/Modules/AOM/Consumables/{id}": {
      "get": {
        "tags": [
          "Consumable"
        ],
        "summary": "Get a Consumable resource.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | Consumable->Code | string |  |\r\n| isActive | Consumable->IsActive | boolean |  |\r\n| createdByUserId | Consumable->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | Consumable->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | Consumable->CreatedByUser_FullName | string |  |\r\n| createdOn | Consumable->CreatedOn | string | date-time |\r\n| modifiedByUserId | Consumable->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | Consumable->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | Consumable->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | Consumable->ModifiedOn | string | date-time |\r\n| version | Consumable->Version | integer | int32 |\r\n| permissionTreeId | Consumable->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | Consumable->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | Consumable->PermissionTree_Description | string |  |\r\n| siteId | Consumable->Site_Id | integer | int64 |\r\n| siteCode | Consumable->Site_Code | string |  |\r\n| siteDescription | Consumable->Site_Description | string |  |\r\n| id | Consumable->Id | integer | int64 |\r\n| currencyId | Consumable->Currency_Id | integer | int64 |\r\n| currencyCode | Consumable->Currency_Code | string |  |\r\n| currencyDescription | Consumable->Currency_Description | string |  |\r\n| description | Consumable->Description | string |  |\r\n| notes | Consumable->Notes | string |  |\r\n| unitOfMeasurementId | Consumable->UnitOfMeasurement_Id | integer | int64 |\r\n| unitOfMeasurementCode | Consumable->UnitOfMeasurement_Code | string |  |\r\n| unitOfMeasurementDescription | Consumable->UnitOfMeasurement_Description | string |  |\r\n| unitPrice | Consumable->UnitPrice | number | decimal |\r\n",
        "operationId": "GetConsumable",
        "produces": [
          "application/vnd.onkey.entity+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Consumable Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Consumable",
            "schema": {
              "$ref": "#/definitions/GetConsumableResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "patch": {
        "tags": [
          "Consumable"
        ],
        "summary": "Update an existing Consumable resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Consumable->Version | integer | int32 |\r\n| code | Consumable->Code | string |  |\r\n| currencyId | Consumable->Currency_Id | integer | int64 |\r\n| description | Consumable->Description | string |  |\r\n| notes | Consumable->Notes | string |  |\r\n| siteId | Consumable->Site_Id | integer | int64 |\r\n| unitOfMeasurementId | Consumable->UnitOfMeasurement_Id | integer | int64 |\r\n| unitPrice | Consumable->UnitPrice | number | decimal |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n| unitPrice | Min Value | >= 0|  |\r\n\r\n",
        "operationId": "UpdateConsumable",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Consumable Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/UpdateConsumableResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Consumable was successfully updated"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "delete": {
        "tags": [
          "Consumable"
        ],
        "summary": "Delete an existing Consumable resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Consumable->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "DeleteConsumable",
        "consumes": [
          "application/vnd.onkey.entitydelete+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Consumable Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "delete",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/DeleteConsumableResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Consumable was successfully deleted"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Consumables": {
      "get": {
        "tags": [
          "Consumable"
        ],
        "summary": "Get a collection of Consumable resources.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Consumable->Version | integer | int32 |\r\n| id | Consumable->Id | integer | int64 |\r\n| code | Consumable->Code | string |  |\r\n| currencyId | Consumable->Currency_Id | integer | int64 |\r\n| currencyCode | Consumable->Currency_Code | string |  |\r\n| currencyDescription | Consumable->Currency_Description | string |  |\r\n| description | Consumable->Description | string |  |\r\n| isActive | Consumable->IsActive | boolean |  |\r\n| siteId | Consumable->Site_Id | integer | int64 |\r\n| siteCode | Consumable->Site_Code | string |  |\r\n| siteDescription | Consumable->Site_Description | string |  |\r\n| unitPrice | Consumable->UnitPrice | number | decimal |\r\n| unitOfMeasurementId | Consumable->UnitOfMeasurement_Id | integer | int64 |\r\n| unitOfMeasurementCode | Consumable->UnitOfMeasurement_Code | string |  |\r\n| unitOfMeasurementDescription | Consumable->UnitOfMeasurement_Description | string |  |\r\n| notes | Consumable->Notes | string |  |\r\n| createdOn | Consumable->CreatedOn | string | date-time |\r\n| modifiedOn | Consumable->ModifiedOn | string | date-time |\r\n",
        "operationId": "GetConsumableCollection",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Consumable collection",
            "schema": {
              "$ref": "#/definitions/GetConsumableCollectionResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "post": {
        "tags": [
          "Consumable"
        ],
        "summary": "Create a new Consumable resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | Consumable->Code | string |  |\r\n| currencyId | Consumable->Currency_Id | integer | int64 |\r\n| description | Consumable->Description | string |  |\r\n| notes | Consumable->Notes | string |  |\r\n| permissionTreeId | Consumable->PermissionTree_Id | integer | int64 |\r\n| siteId | Consumable->Site_Id | integer | int64 |\r\n| unitOfMeasurementId | Consumable->UnitOfMeasurement_Id | integer | int64 |\r\n| unitPrice | Consumable->UnitPrice | number | decimal |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| code | Required | True |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n| unitPrice | Min Value | >= 0|  |\r\n\r\n",
        "operationId": "CreateConsumable",
        "consumes": [
          "application/vnd.onkey.entity+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "post",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/CreateConsumableResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "201": {
            "x-nullable": true,
            "description": "Success response - resource was successfully created",
            "headers": {
              "OnKey-Resource-Id": {
                "type": "integer",
                "description": "Id of the resource created",
                "format": "Int64"
              },
              "OnKey-Resource-Location": {
                "type": "string",
                "description": "Uri to fetch the created resource"
              }
            }
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Consumables/Lookups/LookupConsumableChangePermissionTree": {
      "get": {
        "tags": [
          "Consumable"
        ],
        "summary": "Lookup the permission set for changing the Consumable.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupConsumableChangePermissionTree",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable  collection",
            "schema": {
              "$ref": "#/definitions/ConsumableChangePermissionTreeLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Consumables/Lookups/LookupConsumableCurrency": {
      "get": {
        "tags": [
          "Consumable"
        ],
        "summary": "Lookup Currency for the Consumable",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Currency->Id | integer | int64 |\r\n| code | Currency->Code | string |  |\r\n| description | Currency->Description | string |  |\r\n",
        "operationId": "LookupConsumableCurrency",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Currency collection",
            "schema": {
              "$ref": "#/definitions/ConsumableCurrencyLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Consumables/Lookups/LookupConsumableInsertPermissionTree": {
      "get": {
        "tags": [
          "Consumable"
        ],
        "summary": "Lookup the permission set for creating the Consumable.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupConsumableInsertPermissionTree",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable  collection",
            "schema": {
              "$ref": "#/definitions/ConsumableInsertPermissionTreeLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Consumables/Lookups/LookupConsumableSite": {
      "get": {
        "tags": [
          "Consumable"
        ],
        "summary": "Lookup the Site for the Consumable.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Site->Id | integer | int64 |\r\n| code | Site->Code | string |  |\r\n| description | Site->Description | string |  |\r\n| currencyId | Site->Currency_Id | integer | int64 |\r\n| currencyCode | Site->Currency_Code | string |  |\r\n| currencyDescription | Site->Currency_Description | string |  |\r\n",
        "operationId": "LookupConsumableSite",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Site collection",
            "schema": {
              "$ref": "#/definitions/ConsumableSiteLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Consumables/Lookups/LookupConsumableUnitOfMeasurement": {
      "get": {
        "tags": [
          "Consumable"
        ],
        "summary": "Lookup the Unit Of Measurement for the Consumable.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | UnitOfMeasurement->Id | integer | int64 |\r\n| code | UnitOfMeasurement->Code | string |  |\r\n| description | UnitOfMeasurement->Description | string |  |\r\n",
        "operationId": "LookupConsumableUnitOfMeasurement",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Unit Of Measurement collection",
            "schema": {
              "$ref": "#/definitions/ConsumableUnitOfMeasurementLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Consumables/Batch/{ids}": {
      "get": {
        "tags": [
          "Consumable"
        ],
        "summary": "Get a collection of Consumable resources for the set of id's.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | Consumable->Code | string |  |\r\n| isActive | Consumable->IsActive | boolean |  |\r\n| createdByUserId | Consumable->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | Consumable->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | Consumable->CreatedByUser_FullName | string |  |\r\n| createdOn | Consumable->CreatedOn | string | date-time |\r\n| modifiedByUserId | Consumable->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | Consumable->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | Consumable->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | Consumable->ModifiedOn | string | date-time |\r\n| version | Consumable->Version | integer | int32 |\r\n| permissionTreeId | Consumable->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | Consumable->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | Consumable->PermissionTree_Description | string |  |\r\n| siteId | Consumable->Site_Id | integer | int64 |\r\n| siteCode | Consumable->Site_Code | string |  |\r\n| siteDescription | Consumable->Site_Description | string |  |\r\n| id | Consumable->Id | integer | int64 |\r\n| currencyId | Consumable->Currency_Id | integer | int64 |\r\n| currencyCode | Consumable->Currency_Code | string |  |\r\n| currencyDescription | Consumable->Currency_Description | string |  |\r\n| description | Consumable->Description | string |  |\r\n| notes | Consumable->Notes | string |  |\r\n| unitOfMeasurementId | Consumable->UnitOfMeasurement_Id | integer | int64 |\r\n| unitOfMeasurementCode | Consumable->UnitOfMeasurement_Code | string |  |\r\n| unitOfMeasurementDescription | Consumable->UnitOfMeasurement_Description | string |  |\r\n| unitPrice | Consumable->UnitPrice | number | decimal |\r\n",
        "operationId": "BatchGetConsumable",
        "produces": [
          "application/vnd.onkey.entitycollection+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "array",
            "name": "ids",
            "in": "path",
            "required": true,
            "description": "A comma separated list of Consumable id's (eg. 1585760985950002,1585760985950003)",
            "collectionFormat": "csv",
            "x-nullable": false,
            "items": {
              "type": "integer",
              "format": "int64"
            }
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Consumable collection",
            "schema": {
              "$ref": "#/definitions/BatchGetConsumableResourceAction"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Consumables/Batch": {
      "post": {
        "tags": [
          "Consumable"
        ],
        "summary": "Create a new collection of Consumable resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | Consumable->Code | string |  |\r\n| currencyId | Consumable->Currency_Id | integer | int64 |\r\n| description | Consumable->Description | string |  |\r\n| notes | Consumable->Notes | string |  |\r\n| permissionTreeId | Consumable->PermissionTree_Id | integer | int64 |\r\n| siteId | Consumable->Site_Id | integer | int64 |\r\n| unitOfMeasurementId | Consumable->UnitOfMeasurement_Id | integer | int64 |\r\n| unitPrice | Consumable->UnitPrice | number | decimal |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| code | Required | True |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n| unitPrice | Min Value | >= 0|  |\r\n\r\n",
        "operationId": "BatchCreateConsumable",
        "consumes": [
          "application/vnd.onkey.entitycollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "posts",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchCreateConsumableResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "201": {
            "x-nullable": true,
            "description": "Success response - Consumable batch was successfully created"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "patch": {
        "tags": [
          "Consumable"
        ],
        "summary": "Update a collection of existing Consumable resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Consumable->Id | integer | int64 |\r\n| version | Consumable->Version | integer | int32 |\r\n| code | Consumable->Code | string |  |\r\n| currencyId | Consumable->Currency_Id | integer | int64 |\r\n| description | Consumable->Description | string |  |\r\n| notes | Consumable->Notes | string |  |\r\n| siteId | Consumable->Site_Id | integer | int64 |\r\n| unitOfMeasurementId | Consumable->UnitOfMeasurement_Id | integer | int64 |\r\n| unitPrice | Consumable->UnitPrice | number | decimal |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n| unitPrice | Min Value | >= 0|  |\r\n\r\n",
        "operationId": "BatchUpdateConsumable",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchUpdateConsumableResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Consumable batch was successfully updated"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "delete": {
        "tags": [
          "Consumable"
        ],
        "summary": "Delete a collection of existing Consumable resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Consumable->Id | integer | int64 |\r\n| version | Consumable->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchDeleteConsumable",
        "consumes": [
          "application/vnd.onkey.entitydeletecollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "deletes",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchDeleteConsumableResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Consumable batch was successfully deleted"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Consumables/{id}/Active": {
      "patch": {
        "tags": [
          "Consumable"
        ],
        "summary": "Change the IsActive status for an existing Consumable resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Consumable->Version | integer | int32 |\r\n| isActive | Consumable->IsActive | boolean |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| isActive | Required | True |  |\r\n| isActive | Nullable | False |  |\r\n\r\n",
        "operationId": "ChangeConsumableIsActive",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Consumable Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/ChangeConsumableIsActiveResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Consumables/{id}/PermissionTree": {
      "patch": {
        "tags": [
          "Consumable"
        ],
        "summary": "Change the PermissionTree for an existing Consumable resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Consumable->Version | integer | int32 |\r\n| permissionTreeId | Consumable->PermissionTree_Id | integer | int64 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "ChangeConsumablePermissionTree",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Consumable Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/ChangeConsumablePermissionTreeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Consumables/Batch/Active": {
      "patch": {
        "tags": [
          "Consumable"
        ],
        "summary": "Change the IsActive status for a collection of existing Consumable resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Consumable->Id | integer | int64 |\r\n| version | Consumable->Version | integer | int32 |\r\n| isActive | Consumable->IsActive | boolean |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| isActive | Required | True |  |\r\n| isActive | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchChangeConsumableIsActive",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchChangeConsumableIsActiveResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Consumables/Batch/PermissionTree": {
      "patch": {
        "tags": [
          "Consumable"
        ],
        "summary": "Change the PermissionTree status for a collection of existing Consumable resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Consumable->Id | integer | int64 |\r\n| version | Consumable->Version | integer | int32 |\r\n| permissionTreeId | Consumable->PermissionTree_Id | integer | int64 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchChangeConsumablePermissionTree",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchChangeConsumablePermissionTreeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Meters/{id}": {
      "get": {
        "tags": [
          "Meter"
        ],
        "summary": "Get a Meter resource.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | Meter->Code | string |  |\r\n| isActive | Meter->IsActive | boolean |  |\r\n| createdByUserId | Meter->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | Meter->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | Meter->CreatedByUser_FullName | string |  |\r\n| createdOn | Meter->CreatedOn | string | date-time |\r\n| modifiedByUserId | Meter->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | Meter->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | Meter->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | Meter->ModifiedOn | string | date-time |\r\n| version | Meter->Version | integer | int32 |\r\n| permissionTreeId | Meter->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | Meter->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | Meter->PermissionTree_Description | string |  |\r\n| siteId | Meter->Site_Id | integer | int64 |\r\n| siteCode | Meter->Site_Code | string |  |\r\n| siteDescription | Meter->Site_Description | string |  |\r\n| id | Meter->Id | integer | int64 |\r\n| automaticallyUpdateAverageDailyRate | Meter->AutomaticallyUpdateAverageDailyRate | boolean |  |\r\n| autoResetValue | Meter->AutoResetValue | number | decimal |\r\n| averageDailyRate | Meter->AverageDailyRate | number | decimal |\r\n| averageDailyRateCalculationQuantity | Meter->AverageDailyRateCalculationQuantity | integer | int32 |\r\n| averageDailyRateCalculationUnit | Meter->AverageDailyRateCalculationUnit | string (Allowed values: [ReadingCount, Hours, Days, Weeks, Months, Years]) | enum |\r\n| averageDailyRateMaximumValue | Meter->AverageDailyRateMaximumValue | number | decimal |\r\n| averageDailyRateVariancePercentage | Meter->AverageDailyRateVariancePercentage | number | decimal |\r\n| cumulativeReading | Meter->CumulativeReading | number | decimal |\r\n| description | Meter->Description | string |  |\r\n| isPaused | Meter->IsPaused | boolean |  |\r\n| lastReading | Meter->LastReading | number | decimal |\r\n| lastReadOn | Meter->LastReadOn | string | date-time |\r\n| lastResetOn | Meter->LastResetOn | string | date-time |\r\n| lastResetReading | Meter->LastResetReading | number | decimal |\r\n| notes | Meter->Notes | string |  |\r\n| pmrStatus | Meter->PmrStatus | string (Allowed values: [LatestMeterReadingNotValid, NotUsedByTask, MeterIsInActive, AdrIsZero, Generated, GenerationRequired]) | enum |\r\n| pmrStatusChangedOn | Meter->PmrStatusChangedOn | string | date-time |\r\n| unitOfMeasurementId | Meter->UnitOfMeasurement_Id | integer | int64 |\r\n| unitOfMeasurementCode | Meter->UnitOfMeasurement_Code | string |  |\r\n| unitOfMeasurementDescription | Meter->UnitOfMeasurement_Description | string |  |\r\n| validateAverageDailyRateMaximumValue | Meter->ValidateAverageDailyRateMaximumValue | boolean |  |\r\n| validateAverageDailyRateVariancePercentage | Meter->ValidateAverageDailyRateVariancePercentage | string (Allowed values: [SystemOption, Yes, No]) | enum |\r\n| validateReadings | Meter->ValidateReadings | boolean |  |\r\n",
        "operationId": "GetMeter",
        "produces": [
          "application/vnd.onkey.entity+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Meter Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Meter",
            "schema": {
              "$ref": "#/definitions/GetMeterResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "patch": {
        "tags": [
          "Meter"
        ],
        "summary": "Update an existing Meter resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Meter->Version | integer | int32 |\r\n| code | Meter->Code | string |  |\r\n| description | Meter->Description | string |  |\r\n| unitOfMeasurementId | Meter->UnitOfMeasurement_Id | integer | int64 |\r\n| autoResetValue | Meter->AutoResetValue | number | decimal |\r\n| automaticallyUpdateAverageDailyRate | Meter->AutomaticallyUpdateAverageDailyRate | boolean |  |\r\n| averageDailyRateCalculationQuantity | Meter->AverageDailyRateCalculationQuantity | integer | int32 |\r\n| averageDailyRateCalculationUnit | Meter->AverageDailyRateCalculationUnit | string (Allowed values: [ReadingCount, Hours, Days, Weeks, Months, Years]) | enum |\r\n| averageDailyRate | Meter->AverageDailyRate | number | decimal |\r\n| siteId | Meter->Site_Id | integer | int64 |\r\n| validateReadings | Meter->ValidateReadings | boolean |  |\r\n| validateAverageDailyRateVariancePercentage | Meter->ValidateAverageDailyRateVariancePercentage | string (Allowed values: [SystemOption, Yes, No]) | enum |\r\n| averageDailyRateVariancePercentage | Meter->AverageDailyRateVariancePercentage | number | decimal |\r\n| validateAverageDailyRateMaximumValue | Meter->ValidateAverageDailyRateMaximumValue | boolean |  |\r\n| averageDailyRateMaximumValue | Meter->AverageDailyRateMaximumValue | number | decimal |\r\n| notes | Meter->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n| unitOfMeasurementId | Nullable | False |  |\r\n| autoResetValue | Nullable | True |  |\r\n| automaticallyUpdateAverageDailyRate | Nullable | False |  |\r\n| averageDailyRate | Min Value | >= 0|  |\r\n| validateAverageDailyRateVariancePercentage | Nullable | False |  |\r\n| averageDailyRateVariancePercentage | Nullable | False | Meter->ValidateAverageDailyRateVariancePercentage eq 'Yes' |\r\n| validateAverageDailyRateMaximumValue | Nullable | False |  |\r\n| averageDailyRateMaximumValue | Nullable | False | Meter->ValidateAverageDailyRateMaximumValue eq true |\r\n\r\n",
        "operationId": "UpdateMeter",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Meter Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/UpdateMeterResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Meter was successfully updated"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "delete": {
        "tags": [
          "Meter"
        ],
        "summary": "Delete an existing Meter resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Meter->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "DeleteMeter",
        "consumes": [
          "application/vnd.onkey.entitydelete+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Meter Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "delete",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/DeleteMeterResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Meter was successfully deleted"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Meters": {
      "get": {
        "tags": [
          "Meter"
        ],
        "summary": "Get a collection of Meter resources.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Meter->Version | integer | int32 |\r\n| id | Meter->Id | integer | int64 |\r\n| code | Meter->Code | string |  |\r\n| description | Meter->Description | string |  |\r\n| isActive | Meter->IsActive | boolean |  |\r\n| isPaused | Meter->IsPaused | boolean |  |\r\n| autoResetValue | Meter->AutoResetValue | number | decimal |\r\n| automaticallyUpdateAverageDailyRate | Meter->AutomaticallyUpdateAverageDailyRate | boolean |  |\r\n| averageDailyRateCalculationQuantity | Meter->AverageDailyRateCalculationQuantity | integer | int32 |\r\n| averageDailyRateCalculationUnit | Meter->AverageDailyRateCalculationUnit | string (Allowed values: [ReadingCount, Hours, Days, Weeks, Months, Years]) | enum |\r\n| averageDailyRate | Meter->AverageDailyRate | number | decimal |\r\n| notes | Meter->Notes | string |  |\r\n| siteId | Meter->Site_Id | integer | int64 |\r\n| siteCode | Meter->Site_Code | string |  |\r\n| siteDescription | Meter->Site_Description | string |  |\r\n| unitOfMeasurementId | Meter->UnitOfMeasurement_Id | integer | int64 |\r\n| unitOfMeasurementCode | Meter->UnitOfMeasurement_Code | string |  |\r\n| unitOfMeasurementDescription | Meter->UnitOfMeasurement_Description | string |  |\r\n| createdOn | Meter->CreatedOn | string | date-time |\r\n| modifiedOn | Meter->ModifiedOn | string | date-time |\r\n",
        "operationId": "GetMeterCollection",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Meter collection",
            "schema": {
              "$ref": "#/definitions/GetMeterCollectionResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "post": {
        "tags": [
          "Meter"
        ],
        "summary": "Create a new Meter resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| autoResetValue | Meter->AutoResetValue | number | decimal |\r\n| automaticallyUpdateAverageDailyRate | Meter->AutomaticallyUpdateAverageDailyRate | boolean |  |\r\n| averageDailyRateCalculationQuantity | Meter->AverageDailyRateCalculationQuantity | integer | int32 |\r\n| averageDailyRateCalculationUnit | Meter->AverageDailyRateCalculationUnit | string (Allowed values: [ReadingCount, Hours, Days, Weeks, Months, Years]) | enum |\r\n| averageDailyRateMaximumValue | Meter->AverageDailyRateMaximumValue | number | decimal |\r\n| averageDailyRateVariancePercentage | Meter->AverageDailyRateVariancePercentage | number | decimal |\r\n| code | Meter->Code | string |  |\r\n| description | Meter->Description | string |  |\r\n| isPaused | Meter->IsPaused | boolean |  |\r\n| notes | Meter->Notes | string |  |\r\n| permissionTreeId | Meter->PermissionTree_Id | integer | int64 |\r\n| siteId | Meter->Site_Id | integer | int64 |\r\n| unitOfMeasurementId | Meter->UnitOfMeasurement_Id | integer | int64 |\r\n| validateAverageDailyRateMaximumValue | Meter->ValidateAverageDailyRateMaximumValue | boolean |  |\r\n| validateAverageDailyRateVariancePercentage | Meter->ValidateAverageDailyRateVariancePercentage | string (Allowed values: [SystemOption, Yes, No]) | enum |\r\n| validateReadings | Meter->ValidateReadings | boolean |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| autoResetValue | Nullable | True |  |\r\n| automaticallyUpdateAverageDailyRate | Nullable | False |  |\r\n| averageDailyRateMaximumValue | Nullable | False | Meter->ValidateAverageDailyRateMaximumValue eq true |\r\n| averageDailyRateVariancePercentage | Nullable | False | Meter->ValidateAverageDailyRateVariancePercentage eq 'Yes' |\r\n| code | Required | True |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n| permissionTreeId | System Generated | true | If no value specified |\r\n| permissionTreeId | Nullable | False |  |\r\n| unitOfMeasurementId | Required | True |  |\r\n| unitOfMeasurementId | Nullable | False |  |\r\n| validateAverageDailyRateMaximumValue | Nullable | False |  |\r\n| validateAverageDailyRateVariancePercentage | Nullable | False |  |\r\n\r\n",
        "operationId": "CreateMeter",
        "consumes": [
          "application/vnd.onkey.entity+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "post",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/CreateMeterResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "201": {
            "x-nullable": true,
            "description": "Success response - resource was successfully created",
            "headers": {
              "OnKey-Resource-Id": {
                "type": "integer",
                "description": "Id of the resource created",
                "format": "Int64"
              },
              "OnKey-Resource-Location": {
                "type": "string",
                "description": "Uri to fetch the created resource"
              }
            }
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Meters/Lookups/LookupMeterChangePermissionTree": {
      "get": {
        "tags": [
          "Meter"
        ],
        "summary": "Lookup the permission set for changing the Meter.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupMeterChangePermissionTree",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable  collection",
            "schema": {
              "$ref": "#/definitions/MeterChangePermissionTreeLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Meters/Lookups/LookupMeterInsertPermissionTree": {
      "get": {
        "tags": [
          "Meter"
        ],
        "summary": "Lookup the permission set for creating the Meter.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupMeterInsertPermissionTree",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable  collection",
            "schema": {
              "$ref": "#/definitions/MeterInsertPermissionTreeLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Meters/Lookups/LookupMeterSite": {
      "get": {
        "tags": [
          "Meter"
        ],
        "summary": "Lookup the Site for the Meter.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Site->Id | integer | int64 |\r\n| code | Site->Code | string |  |\r\n| description | Site->Description | string |  |\r\n",
        "operationId": "LookupMeterSite",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Site collection",
            "schema": {
              "$ref": "#/definitions/MeterSiteLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Meters/Lookups/LookupMeterUnitOfMeasurement": {
      "get": {
        "tags": [
          "Meter"
        ],
        "summary": "Lookup the Unit Of Measurement for the Meter.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | UnitOfMeasurement->Id | integer | int64 |\r\n| code | UnitOfMeasurement->Code | string |  |\r\n| description | UnitOfMeasurement->Description | string |  |\r\n",
        "operationId": "LookupMeterUnitOfMeasurement",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Unit Of Measurement collection",
            "schema": {
              "$ref": "#/definitions/MeterUnitOfMeasurementLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Meters/Batch/{ids}": {
      "get": {
        "tags": [
          "Meter"
        ],
        "summary": "Get a collection of Meter resources for the set of id's.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | Meter->Code | string |  |\r\n| isActive | Meter->IsActive | boolean |  |\r\n| createdByUserId | Meter->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | Meter->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | Meter->CreatedByUser_FullName | string |  |\r\n| createdOn | Meter->CreatedOn | string | date-time |\r\n| modifiedByUserId | Meter->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | Meter->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | Meter->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | Meter->ModifiedOn | string | date-time |\r\n| version | Meter->Version | integer | int32 |\r\n| permissionTreeId | Meter->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | Meter->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | Meter->PermissionTree_Description | string |  |\r\n| siteId | Meter->Site_Id | integer | int64 |\r\n| siteCode | Meter->Site_Code | string |  |\r\n| siteDescription | Meter->Site_Description | string |  |\r\n| id | Meter->Id | integer | int64 |\r\n| automaticallyUpdateAverageDailyRate | Meter->AutomaticallyUpdateAverageDailyRate | boolean |  |\r\n| autoResetValue | Meter->AutoResetValue | number | decimal |\r\n| averageDailyRate | Meter->AverageDailyRate | number | decimal |\r\n| averageDailyRateCalculationQuantity | Meter->AverageDailyRateCalculationQuantity | integer | int32 |\r\n| averageDailyRateCalculationUnit | Meter->AverageDailyRateCalculationUnit | string (Allowed values: [ReadingCount, Hours, Days, Weeks, Months, Years]) | enum |\r\n| averageDailyRateMaximumValue | Meter->AverageDailyRateMaximumValue | number | decimal |\r\n| averageDailyRateVariancePercentage | Meter->AverageDailyRateVariancePercentage | number | decimal |\r\n| cumulativeReading | Meter->CumulativeReading | number | decimal |\r\n| description | Meter->Description | string |  |\r\n| isPaused | Meter->IsPaused | boolean |  |\r\n| lastReading | Meter->LastReading | number | decimal |\r\n| lastReadOn | Meter->LastReadOn | string | date-time |\r\n| lastResetOn | Meter->LastResetOn | string | date-time |\r\n| lastResetReading | Meter->LastResetReading | number | decimal |\r\n| notes | Meter->Notes | string |  |\r\n| pmrStatus | Meter->PmrStatus | string (Allowed values: [LatestMeterReadingNotValid, NotUsedByTask, MeterIsInActive, AdrIsZero, Generated, GenerationRequired]) | enum |\r\n| pmrStatusChangedOn | Meter->PmrStatusChangedOn | string | date-time |\r\n| unitOfMeasurementId | Meter->UnitOfMeasurement_Id | integer | int64 |\r\n| unitOfMeasurementCode | Meter->UnitOfMeasurement_Code | string |  |\r\n| unitOfMeasurementDescription | Meter->UnitOfMeasurement_Description | string |  |\r\n| validateAverageDailyRateMaximumValue | Meter->ValidateAverageDailyRateMaximumValue | boolean |  |\r\n| validateAverageDailyRateVariancePercentage | Meter->ValidateAverageDailyRateVariancePercentage | string (Allowed values: [SystemOption, Yes, No]) | enum |\r\n| validateReadings | Meter->ValidateReadings | boolean |  |\r\n",
        "operationId": "BatchGetMeter",
        "produces": [
          "application/vnd.onkey.entitycollection+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "array",
            "name": "ids",
            "in": "path",
            "required": true,
            "description": "A comma separated list of Meter id's (eg. 1585760985950002,1585760985950003)",
            "collectionFormat": "csv",
            "x-nullable": false,
            "items": {
              "type": "integer",
              "format": "int64"
            }
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Meter collection",
            "schema": {
              "$ref": "#/definitions/BatchGetMeterResourceAction"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Meters/Batch": {
      "post": {
        "tags": [
          "Meter"
        ],
        "summary": "Create a new collection of Meter resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| autoResetValue | Meter->AutoResetValue | number | decimal |\r\n| automaticallyUpdateAverageDailyRate | Meter->AutomaticallyUpdateAverageDailyRate | boolean |  |\r\n| averageDailyRateCalculationQuantity | Meter->AverageDailyRateCalculationQuantity | integer | int32 |\r\n| averageDailyRateCalculationUnit | Meter->AverageDailyRateCalculationUnit | string (Allowed values: [ReadingCount, Hours, Days, Weeks, Months, Years]) | enum |\r\n| averageDailyRateMaximumValue | Meter->AverageDailyRateMaximumValue | number | decimal |\r\n| averageDailyRateVariancePercentage | Meter->AverageDailyRateVariancePercentage | number | decimal |\r\n| code | Meter->Code | string |  |\r\n| description | Meter->Description | string |  |\r\n| isPaused | Meter->IsPaused | boolean |  |\r\n| notes | Meter->Notes | string |  |\r\n| permissionTreeId | Meter->PermissionTree_Id | integer | int64 |\r\n| siteId | Meter->Site_Id | integer | int64 |\r\n| unitOfMeasurementId | Meter->UnitOfMeasurement_Id | integer | int64 |\r\n| validateAverageDailyRateMaximumValue | Meter->ValidateAverageDailyRateMaximumValue | boolean |  |\r\n| validateAverageDailyRateVariancePercentage | Meter->ValidateAverageDailyRateVariancePercentage | string (Allowed values: [SystemOption, Yes, No]) | enum |\r\n| validateReadings | Meter->ValidateReadings | boolean |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| autoResetValue | Nullable | True |  |\r\n| automaticallyUpdateAverageDailyRate | Nullable | False |  |\r\n| averageDailyRateMaximumValue | Nullable | False | Meter->ValidateAverageDailyRateMaximumValue eq true |\r\n| averageDailyRateVariancePercentage | Nullable | False | Meter->ValidateAverageDailyRateVariancePercentage eq 'Yes' |\r\n| code | Required | True |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n| permissionTreeId | System Generated | true | If no value specified |\r\n| permissionTreeId | Nullable | False |  |\r\n| unitOfMeasurementId | Required | True |  |\r\n| unitOfMeasurementId | Nullable | False |  |\r\n| validateAverageDailyRateMaximumValue | Nullable | False |  |\r\n| validateAverageDailyRateVariancePercentage | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchCreateMeter",
        "consumes": [
          "application/vnd.onkey.entitycollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "posts",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchCreateMeterResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "201": {
            "x-nullable": true,
            "description": "Success response - Meter batch was successfully created"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "patch": {
        "tags": [
          "Meter"
        ],
        "summary": "Update a collection of existing Meter resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Meter->Id | integer | int64 |\r\n| version | Meter->Version | integer | int32 |\r\n| code | Meter->Code | string |  |\r\n| description | Meter->Description | string |  |\r\n| unitOfMeasurementId | Meter->UnitOfMeasurement_Id | integer | int64 |\r\n| isPaused | Meter->IsPaused | boolean |  |\r\n| autoResetValue | Meter->AutoResetValue | number | decimal |\r\n| automaticallyUpdateAverageDailyRate | Meter->AutomaticallyUpdateAverageDailyRate | boolean |  |\r\n| averageDailyRateCalculationQuantity | Meter->AverageDailyRateCalculationQuantity | integer | int32 |\r\n| averageDailyRateCalculationUnit | Meter->AverageDailyRateCalculationUnit | string (Allowed values: [ReadingCount, Hours, Days, Weeks, Months, Years]) | enum |\r\n| averageDailyRate | Meter->AverageDailyRate | number | decimal |\r\n| siteId | Meter->Site_Id | integer | int64 |\r\n| validateReadings | Meter->ValidateReadings | boolean |  |\r\n| validateAverageDailyRateVariancePercentage | Meter->ValidateAverageDailyRateVariancePercentage | string (Allowed values: [SystemOption, Yes, No]) | enum |\r\n| averageDailyRateVariancePercentage | Meter->AverageDailyRateVariancePercentage | number | decimal |\r\n| validateAverageDailyRateMaximumValue | Meter->ValidateAverageDailyRateMaximumValue | boolean |  |\r\n| averageDailyRateMaximumValue | Meter->AverageDailyRateMaximumValue | number | decimal |\r\n| notes | Meter->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n| unitOfMeasurementId | Nullable | False |  |\r\n| autoResetValue | Nullable | True |  |\r\n| automaticallyUpdateAverageDailyRate | Nullable | False |  |\r\n| averageDailyRate | Min Value | >= 0|  |\r\n| validateAverageDailyRateVariancePercentage | Nullable | False |  |\r\n| averageDailyRateVariancePercentage | Nullable | False | Meter->ValidateAverageDailyRateVariancePercentage eq 'Yes' |\r\n| validateAverageDailyRateMaximumValue | Nullable | False |  |\r\n| averageDailyRateMaximumValue | Nullable | False | Meter->ValidateAverageDailyRateMaximumValue eq true |\r\n\r\n",
        "operationId": "BatchUpdateMeter",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchUpdateMeterResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Meter batch was successfully updated"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "delete": {
        "tags": [
          "Meter"
        ],
        "summary": "Delete a collection of existing Meter resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Meter->Id | integer | int64 |\r\n| version | Meter->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchDeleteMeter",
        "consumes": [
          "application/vnd.onkey.entitydeletecollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "deletes",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchDeleteMeterResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Meter batch was successfully deleted"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Meters/AverageDailyRate/Batch": {
      "patch": {
        "tags": [
          "Meter"
        ],
        "summary": "Batch Change the Average Daily Rate for the Meter.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | ChangeMeterAverageDailyRate->Id | integer | int64 |\r\n| version | ChangeMeterAverageDailyRate->Version | integer | int32 |\r\n| averageDailyRate | ChangeMeterAverageDailyRate->AverageDailyRate | number | decimal |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| averageDailyRate | Required | True |  |\r\n| averageDailyRate | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchChangeMeterAverageDailyRate",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchChangeMeterAverageDailyRateResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Meters/Batch/{meterIds}/GeneratePredictedMeterReadings": {
      "post": {
        "tags": [
          "Meter"
        ],
        "summary": "Batch Generate Predicted Meter Readings for Meters",
        "description": "",
        "operationId": "BatchGeneratePredictedMeterReadings",
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "array",
            "name": "meterIds",
            "in": "path",
            "required": true,
            "description": "A comma separated list of Meter id's (eg. 1585760985950002,1585760985950003)",
            "collectionFormat": "csv",
            "x-nullable": false,
            "items": {
              "type": "integer",
              "format": "int64"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AOM/Meters/Pause/Batch": {
      "patch": {
        "tags": [
          "Meter"
        ],
        "summary": "Batch Pause the Meter.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | ResumePauseMeter->Id | integer | int64 |\r\n| version | ResumePauseMeter->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchPauseMeter",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchPauseMeterResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
[...]
